//+------------------------------------------------------------------+
//|                                                   ZigZag_fun.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <FormLog.mqh>

int level=2;
bool downloadhistory=false;
int ExtDepth=12;
int ExtDeviation=5;
int ExtBackstep=3;

bool GetZigZag(int Number,string symbol, int timeframe, 
                   bool NullBarRecount, 
                   double &ZigZagBuffer[], 
                   double &HighMapBuffer[],
                   double &LowMapBuffer[],
                   datetime &ZigZagTime[],datetime &HighMapTime[],datetime &LowMapTime[])
 {
 
   int i;
   int counterZ,whatlookfor;
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow; datetime curlowtime,curhightime,valtime;
 
  datetime lasthightime,lastlowtime;
 //----     
  int IBARS = iBars(symbol, timeframe);
//----        

//----   
   if(ArraySize(ZigZagBuffer) < IBARS)
     {
       ArraySetAsSeries(ZigZagBuffer, false);
       ArraySetAsSeries(HighMapBuffer, false);
       ArraySetAsSeries(LowMapBuffer, false);
       ArraySetAsSeries(ZigZagTime,false);
       ArraySetAsSeries(HighMapTime,false);
       ArraySetAsSeries(LowMapTime,false);
       //----  
       
       ArrayResize(ZigZagBuffer, IBARS); 
       ArrayResize(HighMapBuffer, IBARS); 
       ArrayResize(LowMapBuffer, IBARS); 
       ArrayResize(ZigZagTime, IBARS); 
       ArrayResize(HighMapTime, IBARS); 
       ArrayResize(LowMapTime, IBARS); 
      
       //----
       ArraySetAsSeries(ZigZagBuffer, true);
       ArraySetAsSeries(HighMapBuffer, true);
       ArraySetAsSeries(LowMapBuffer, true);
       ArraySetAsSeries(ZigZagTime,true);
       ArraySetAsSeries(HighMapTime,true);
       ArraySetAsSeries(LowMapTime,true);
       
       
       AddDebugLog("");
     } 
//----+     
   static int IndCounted[];
//----+    
   if(ArraySize(IndCounted) < Number + 1)
       ArrayResize(IndCounted, Number + 1); 
 //----+   
   int LastCountBar;
//----+     
   if(!NullBarRecount)
       LastCountBar = 1;
   else 
       LastCountBar = 0;
//----+     
   double Resalt0, Resalt1, Resalt2;
//----+         
   int limit, MaxBar, bar, counted_bars = IndCounted[Number];
//----+     (    !)
   IndCounted[Number] = IBARS - 1;
//----     , 
//        
   limit = IBARS - counted_bars - 1; 

  
 if (counted_bars==0 && downloadhistory) // history was downloaded
     {
       AddDebugLog(" ");
      ArrayInitialize(ZigZagBuffer,0.0);
      ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
      ArrayInitialize(ZigZagTime,0);
      ArrayInitialize(HighMapTime,0);
      ArrayInitialize(LowMapTime,0);
    
     }
 if (counted_bars==0) 
     {
      limit=IBARS-ExtDepth;
      downloadhistory=true;
     }
     
if (counted_bars>0) 
     {
      while (counterZ<level && i<100)
        {
         res=ZigZagBuffer[i];
         if (res!=0) counterZ++;
         i++;
        }
      i--;
      limit=i;
      if (LowMapBuffer[i]!=0) 
        {
         curlow=LowMapBuffer[i];
         curlowtime=LowMapTime[i];
         whatlookfor=1;
        }
   else        {
         
         whatlookfor=-1;
        }
      for (i=limit-1;i>=0;i--)  
        {
         ZigZagBuffer[i]=0.0;  
         LowMapBuffer[i]=0.0;
         HighMapBuffer[i]=0.0;
         ZigZagTime[i]=0;
         LowMapTime[i]=0;
         HighMapTime[i]=0;
         
        }
     }
      AddDebugLog("");
     for(shift=limit; shift>=0; shift--)
     {
      AddDebugLog(shift); 
     val=iLow(symbol,timeframe,iLowest(symbol,timeframe,MODE_LOW,ExtDepth,shift));
     valtime=iTime(symbol,timeframe,iLowest(symbol,timeframe,MODE_LOW,ExtDepth,shift));
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         lastlowtime=valtime;
         if((iLow(symbol,timeframe,shift)-val)>(ExtDeviation*Point)) { val=0.0; valtime=0;}
         else
           {
            for(back=1; back<ExtBackstep; back++)
              {
               res=LowMapBuffer[shift+back];
               if((res!=0)&&(res>val)){ 
               LowMapBuffer[shift+back]=0.0; 
               LowMapTime[shift+back]=0;
               }
              }
           }
        } 
      if (iLow(symbol,timeframe,shift)==val){ 
      LowMapBuffer[shift]=val;
      LowMapTime[shift]=valtime;
       }
      else { LowMapBuffer[shift]=0.0;LowMapTime[shift]=0; }
      //--- high
      val=iHigh(symbol,timeframe,iHighest(symbol,timeframe,MODE_HIGH,ExtDepth,shift));
      valtime=iTime(symbol,timeframe,iHighest(symbol,timeframe,MODE_HIGH,ExtDepth,shift));
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         lasthightime=valtime;
         if((val-iHigh(symbol,timeframe,shift))>(ExtDeviation*Point)) {val=0.0;lasthightime=0;}
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighMapBuffer[shift+back];
               if((res!=0)&&(res<val)){ HighMapBuffer[shift+back]=0.0; HighMapTime[shift+back]=0;}
              } 
           }
        }
      if (iHigh(symbol,timeframe,shift)==val)
      { 
      HighMapBuffer[shift]=val;
      HighMapTime[shift]=lasthightime;
       }
      else { HighMapBuffer[shift]=0.0; HighMapTime[shift]=0;}
     }
// final cutting 
   if (whatlookfor==0)
     {
      lastlow=0;
      lasthigh=0;  
      lastlowtime=0;
      lasthigh=0;
     }
   else
     {
      lastlow=curlow;
      lasthigh=curhigh;
      lastlowtime= curlowtime;
      lasthightime=curhightime;
     }
     
for (shift=limit;shift>=0;shift--)
     {
      res=0.0;
    AddDebugLog(shift);
      switch(whatlookfor)
        {
        
         case 0: // look for peak or lawn 
         AddDebugLog("case 0: look for lawn or peak");
            if (lastlow==0 && lasthigh==0)
              {
              AddDebugLog("if (lastlow==0 && lasthigh==0)");
               if (HighMapBuffer[shift]!=0)
                 {
                 AddDebugLog("if (HighMapBuffer[shift]!=0)");
                  lasthigh=iHigh(symbol,timeframe,shift);
                  lasthightime=iTime(symbol,timeframe,shift);
                  
                  lasthighpos=shift;
                  whatlookfor=-1;
                  
                  ZigZagBuffer[shift]=lasthigh;
                  ZigZagTime[shift]=lasthightime;
                  
                  res=1;
                 }
               if (LowMapBuffer[shift]!=0)
                 {
                AddDebugLog("if (LowMapBuffer[shift]!=0)"); 
                  lastlow=iLow(symbol,timeframe,shift);
                  lastlowtime=iTime(symbol,timeframe,shift);
                  lastlowpos=shift;
                  whatlookfor=1;
                  ZigZagBuffer[shift]=lastlow;
                  ZigZagTime[shift]=lastlowtime;
                  res=1;
                 }
              }
             break;  
         case 1: // look for peak
         AddDebugLog("look for peak lastpeak ="+DoubleToStr(lasthigh,5));
            if (LowMapBuffer[shift]!=0.0 && LowMapBuffer[shift]<lastlow && HighMapBuffer[shift]==0.0)
              {
               ZigZagBuffer[lastlowpos]=0.0;
               lastlowpos=shift;
               lastlow=LowMapBuffer[shift];
               lastlowtime=LowMapTime[shift];
               ZigZagBuffer[shift]=lastlow;
               ZigZagTime[shift]= lastlowtime;
               
               res=1;
              }
            if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)
              {
              AddDebugLog("if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)");
               lasthigh=HighMapBuffer[shift];
               lasthightime=HighMapTime[shift];
               lasthighpos=shift;
               ZigZagBuffer[shift]=lasthigh;
               ZigZagTime[shift]= lasthightime;
               whatlookfor=-1;
               res=1;
              }   
            break;               
         case -1: // look for lawn
             AddDebugLog("look for lawn ="+DoubleToStr(lastlow,5));
            if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)
              {
               AddDebugLog("if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)");
               ZigZagBuffer[lasthighpos]=0.0;
               lasthighpos=shift;
               lasthigh=HighMapBuffer[shift];
               lasthightime=HighMapTime[shift];
               ZigZagBuffer[shift]=lasthigh;
               ZigZagTime[shift]= lasthightime;
              //AddDebugLog("look for lawn lasthigh ="+DoubleToStr(lasthigh,5));   
              }
            if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)
              {
            AddDebugLog("if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)"); 
               lastlow=LowMapBuffer[shift];
               lastlowtime=LowMapTime[shift];
               lastlowpos=shift;
               ZigZagBuffer[shift]=lastlow;
               ZigZagTime[shift]= lastlowtime;
               
               whatlookfor=1;
              }   
            break;               
         default: return; 
        }
        
     }

   return(0);
}
                   
                   
                   